; --+--+----+--+----+--+----+--+----+--+----+--+----+--+----+--+--
;      MCK-WATCH 2.61 system
;				for Win9x/Me/NT/2000/XP series
; --+--+----+--+----+--+----+--+----+--+----+--+----+--+----+--+--

	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"
	#include "dragdrop.as"

; ---------- ---------- ---------- ---------- ---------- ----------
; Initialize section
; ---------- ---------- ---------- ---------- ---------- ----------

	ver="MCKwatch2.61 Ver2.0 Lev.14"

	title ver
	sdim mml,32000 : sdim fpath,512 : sdim dpath,512
	sdim temp,2048 : sdim cprm,1024 : sdim ppmsg,2048
	sdim ddpath,512 : sdim ddin,1024 : dim prchk,20
	dim ftms,24 : dim ftbk,24 : dim wsiz,8 : z=0

	chdir exedir

	wsiz=700,300,0,0,0,0,0
	exist exedir+"\\mckwinit.ini"
	if strsize!=-1 {
		bload exedir+"\\mckwinit.ini",wsiz
		lang=wsiz.4 : plyr=wsiz.5 : lmck=wsiz.6 : nwnsm=wsiz.7 }

	screen 0,dispx,dispy,2,wsiz.2,wsiz.3 : cls 1
	objmode 2,1 : font "Arial",12 : objsize 60,20
	mref bmscr, 67
	prm = bmscr.13, -16
	dllproc "GetWindowLongA", prm, 2 ,D_USER
	prm.2 = dllret | 0x50000
	dllproc "SetWindowLongA", prm, 3, D_USER
	width wsiz.0,wsiz.1,wsiz.2,wsiz.3

	pos 000,030 : mesbox mml,winx,winy-30,5,32000		;#0
	pos 005,005 : button "sleep",*btn			;#1
	pos 075,005 : button "load",*btn			;#2
	pos 135,005 : button "save",*btn			;#3
	pos 195,005 : button "mckc",*btn			;#4
	pos 255,005 : button "nesasm",*btn			;#5
	pos 325,005 : button "Play",*btn			;#6
	pos 395,005 : chkbox "JPlang",lang			;#7
	objsize 90,20
	pos 455,003 : combox lmck,100,"mck\nmck-bdt\npmck"	;#8
	pos 545,003 : combox plyr,100,"DoubleClick\nVirtuaNSF\nG-NSF"	;#9
	pos 635,005 : chkbox "NewNesm",nwnsm			;#10
	gsel 0,1 : onexit *pg_end
	dd_accept ddin,dd,0
	if cmdline!="" {
		ddin=cmdline : strlen a,ddin : a=a-2 : strmid temp,ddin,0,1
		if temp="\"" {
			strmid ddin,ddin,1,a
		}
		dirlist nsfnam,ddin
		getpath ddin,ddin,32 : ddin+="\\"+nsfnam
		nsfnam="" : dd=1 : goto *ddchk
	}

; ---------- ---------- ---------- ---------- ---------- ----------
; MAIN ROUTINE
; ---------- ---------- ---------- ---------- ---------- ----------
*main
	if dd : goto *ddchk

	rundir=exedir+"\\mck"

	if (x!=winx)|(y!=winy) {
		wsiz=winx,winy-30,0,30 : x=winx : y=winy
		resizeobj 0,wsiz : objsel 0 }

	if (wat!=wbk) {
		if wat=1 { objprm 1,"watch" } else { objprm 1,"sleep" }
		wbk=wat : objsel 0
		}

	if (lang!=lgbk) {
		if lang=1 { font "lr SVbN",14 } else { font "Arial",14 }
		clrobj 0,0 : pos 0,30 : mesbox mml,winx,winy-30,5,32000
		lgbk=lang : objsel 0
		}

	if wat=1 {
		fxtget ftms,fpath : a=8 : b=0
		repeat 8 : if (ftms.a!=ftbk.a) : b=1
		a++ : loop : if b=1 : goto *compl
		}

	if z=1 : z=0 : goto *compl

	ginfo 1 : getkey a,17 : getkey b,83 : exist fpath
	if (a=1)&(b=1)&(prmx=0)&(strsize!=-1) : goto *f_sv

; F1 key
	getkey b,112
	if (b=1)&(prmx=0) {
		exist exedir+"\\Mckwuty.exe"
		if strsize>-1 : exec exedir+"\\Mckwuty.exe",0
		}

; F4 key 
	getkey b,115
	if (b=1)&(prmx=0) : goto *cv_files

	getkey b,80
	if (a=1)&(b=1)&(prmx=0) : goto *nsfplay

	getkey a,27 : if (a=1)&(prmx=0) : goto *pg_end

	exist fpath
	if strsize=-1 { objgray 1,0 } else { objgray 1,1 }

	exist rundir+"\\err_mckc.txt"
	if strsize=-1 { objgray 4,0 } else { objgray 4,1 }

	exist rundir+"\\err_nesm.txt"
	if strsize=-1 { objgray 5,0 } else { objgray 5,1 }

	exist dpath+nsfnam+".nsf"
	if strsize=-1 { objgray 6,0 } else { objgray 6,1 }

	wait 3 : goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; BUTTON OPERATION
; ---------- ---------- ---------- ---------- ---------- ----------
*btn
	a=stat
	if a=1 : wat+=1-((wat=1)*2)
	if a=2 : wat=0 : goto *f_ld
	if a=3 : goto *f_sv
	if a=4 : exec rundir+"\\err_mckc.txt",16
	if a=5 : exec rundir+"\\err_nesm.txt",16
	if a=6 : goto *nsfplay
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; DRAG & DROP CHECKSUM
; ---------- ---------- ---------- ---------- ---------- ----------
*ddchk
	if dd!=1 {
		if lang=0 : dialog "Not Support multi-files",1,"ERROR"
		if lang=1 : dialog "t@C̑I͂ł܂",1,"ERROR"
		dd=0 : goto *main
	}
	notesel ddin : noteget ddpath,0
	dd=0 : fpath=ddpath : charupper fpath : getpath cprm,fpath,2
	if (cprm!=".MML")&(cprm!=".MUS")&(cprm!=".MCK") {
		if lang=0 : dialog "Not support.\n.mml / .mck / .mus type.",1,"ERROR"
		if lang=1 : dialog "T|[gĂȂ`ł.\n.mml / .mck / .mus ̂݉\ł.",1,"ERROR"
		dd=0 : goto *main
	}
	fpath=ddpath
	goto *f_ld2

; ---------- ---------- ---------- ---------- ---------- ----------
; FILE SAVE / LOAD
; ---------- ---------- ---------- ---------- ---------- ----------
*f_sv
	if (fpath="")|(fnam="") {
		fnam="songdata.mml" : fpath=exedir+"\\"+fnam : z=1 : wat=1
		}
	title "overwrite "+fpath
	notesel mml : notesave fpath
	wait 50 : title ver+" - "+fnam
	if z=1 : goto *f_ld2
	goto *main
*f_ld
	dialog "mml;*.mck;*.mus",16,"MML SOURCE"
	if stat=0 : goto *main
	fpath=refstr
*f_ld2
	mml="" : dpath="" : fnam="" : nsfnam=""
	notesel mml : noteload fpath : objprm 0,mml : wait 1
	getpath fnam,fpath,8 : getpath nsfnam,fpath,9
	getpath dpath,fpath,32

	a=0 : strlen b,nsfnam
	repeat b : strmid cprm,nsfnam,cnt,1 : if cprm="-" : a=1
	loop : if a=1 {
		if lang=0 : dialog "Don't use - character in filename.",1,"WARNING"
		if lang=1 : dialog "- (nCt) ̓t@CɎg܂.",1,"WARNING"
		mml="" : fpath="" : dpath="" : fnam="" : nsfnam="" : objprm 0,""
		wat=0 : title ver : goto *main
	}
	fxtget ftms,fpath : fxtget ftbk,fpath
	wat=1 : title ver+" - "+fnam
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; CALL PLAYER
; ---------- ---------- ---------- ---------- ---------- ----------
*nsfplay

	if plyr=1 : exist exedir+"\\VirtuaNSF.exe"
	if plyr=2 : exist exedir+"\\GNSF.exe"
	if strsize=-1 {
		if lang=0 : dialog "Player exec not found.",1,"ERROR"
		if lang=1 : dialog "tvC[܂.",1,"ERROR"
		goto *main }
	exist dpath+nsfnam+".nsf"
	if strsize=-1 {
		if lang=0 : dialog "NSF-FILE NOT FOUND.",1,"ERROR"
		if lang=1 : dialog "NSFt@C܂.",1,"ERROR"
		goto *main }
	if plyr=0 : exec dpath+nsfnam+".nsf",16
	if plyr=1 : exec exedir+"\\VirtuaNSF.exe \""+dpath+nsfnam+".nsf\"",0
	if plyr=2 : exec exedir+"\\GNSF.exe \""+dpath+nsfnam+".nsf\"",0

	repeat : stick a,1,0 : if a=0 : break
	wait 5 : loop
	goto *main

; ---------- ---------- ---------- ---------- ---------- ----------
; PROGRAM ESCAPE (INI GENERATE)
; ---------- ---------- ---------- ---------- ---------- ----------
*pg_end
	dd_reject 0,0
	ginfo 2 : wsiz=winx+2,winy+2,prmx,prmy,lang,plyr,lmck,nwnsm
	bsave exedir+"\\mckwinit.ini",wsiz
	end

; ---------- ---------- ---------- ---------- ---------- ----------
; COMPILE ROUTINE
; ---------- ---------- ---------- ---------- ---------- ----------
*compl
	dd_reject 0,0
	fxtget ftbk,fpath : fxtget ftms,fpath
	title "Delete old files."
	repeat 9 : objgray cnt+1,0 : loop

	cprm="" : chdir exedir : dirlist cprm,"mck",5
	notesel cprm : noteget cprm,0
	if cprm="" {
		if lang=0 : dialog "running directory not found.",1,"ERROR"
		if lang=1 : dialog "ϊtH_܂.",1,"ERROR"
		goto *escap
	}

	chdir rundir
	exist "err_mckc.txt" : if strsize!=-1 : delete "err_mckc.txt"
	exist "err_nesm.txt" : if strsize!=-1 : delete "err_nesm.txt"
	exist dpath+nsfnam+".nsf" : if strsize!=-1 : delete dpath+nsfnam+".nsf"
	exist nsfnam+".nsf" : if strsize!=-1 : delete nsfnam+".nsf"
	exist nsfnam+".h" : if strsize!=-1 : delete nsfnam+".h"
	wait 15

	title "Program Check."
	exist "nesasm.exe"
	if strsize=-1 {
		if lang=0 : dialog "nesasm.exe not found.",1,"ERROR"
		if lang=1 : dialog "nesasm.exe ܂.",1,"ERROR"
		goto *escap
		}

; --------------- (normal mck)
    if lmck=0 {
	exist "mckc.exe"
	if strsize=-1 {
		if lang=0 : dialog "mckc.exe not found.",1,"ERROR"
		if lang=1 : dialog "mckc.exe ܂.",1,"ERROR"
		goto *escap
		}

	exist "make_nsf.txt"
	if strsize=-1 {
		if lang=0 : dialog "mck system broken.",1,"ERROR"
		if lang=1 : dialog "mck ɕKvȃZbgĂ܂.",1,"ERROR"
		goto *escap
		}
	}
; --------------- (mck-bdt / long-mck)
    if lmck=1 {
	exist "bdtmckc.exe"
	if strsize=-1 {
		if lang=0 : dialog "bdtmckc.exe not found.",1,"ERROR"
		if lang=1 : dialog "bdtmckc.exe ܂.",1,"ERROR"
		goto *escap
		}

	exist "make_bdt.txt"
	if strsize=-1 {
		if lang=0 : dialog "bdt-mck system broken.",1,"ERROR"
		if lang=1 : dialog "bdt-mck ɕKvȃZbgĂ܂.",1,"ERROR"
		goto *escap
		}
	}
; --------------- (pmck)
    if lmck=2 {
	exist "pmckc.exe"
	if strsize=-1 {
		if lang=0 : dialog "pmckc.exe not found.",1,"ERROR"
		if lang=1 : dialog "pmckc.exe ܂.",1,"ERROR"
		goto *escap
		}

	exist "make_pmc.txt"
	if strsize=-1 {
		if lang=0 : dialog "pmck system broken.",1,"ERROR"
		if lang=1 : dialog "pmck ɕKvȃZbgĂ܂.",1,"ERROR"
		goto *escap
		}
	}


	wait 15

;  MCKC compile routine
; ----------------------
	temp="" : ppmsg="" : a=0 : b=0

	if lmck=0 : cprm="mckc.exe"
	if lmck=1 : cprm="bdtmckc.exe"
	if lmck=2 : cprm="pmckc.exe"

	cprm+=" -i \""+fpath+"\" "+nsfnam+".h"

	pipeexec temp,cprm
	repeat : pipeget ppmsg : if stat=0 : break
	title "MCKC compile running. [ "+a+" / 400 ]"
	a++ : if a>400 : b=1 : break
	wait 20 : loop
	notesel temp : notesave "err_mckc.txt"
	if b=1 {
		if lang=0 : dialog "loop count overflow.",1,"WARNING."
		if lang=1 : dialog "EFCgɒB܂.\n𒆎~܂.",1,"WARNING"
		goto *escap
	}
	wait 20
	exist "effect.h"
	if strsize=-1 {
		if lang=0 : dialog "mckc compile abort.",1,"ERROR"
		if lang=1 : dialog "mckc ̃RpCɎs܂.",1,"ERROR"
		exec exedir+"\\mck\\err_mckc.txt",16
		goto *escap
	}

;  NESASM compile routine
; ------------------------
		if lmck=0 : cprm="nesasm.exe -raw make_nsf.txt >> err_nesm.txt"
		if lmck=1 : cprm="nesasm.exe -raw make_bdt.txt >> err_nesm.txt"
		if lmck=2 : cprm="nesasm.exe -raw make_pmc.txt >> err_nesm.txt"
	if nwnsm=0 {
		exec cprm,2
		wait 30 : a=0 : b=0
		repeat
		title "NESASM compile running.[ "+a+" / 300 ]"
		exist "err_nesm.txt" : if strsize!=-1 : break
		a++ : if a>300 : b=1 : break
		wait 20 : loop
		}
	if nwnsm=1 {
		title "Hi-Speed NESASM batchfile creating."
		exist "nwnsm.bat" : if strsize!=-1 : delete "nwnsm.bat" : wait 20
		cprm="cd "+exedir+"\\mck\n"+cprm+"\n"
		notesel cprm : notesave "nwnsm.bat" : wait 30
		title "Hi-Speed NESASM batchfile running."
		exec "nwnsm.bat",16 : wait 100
		a=0 : b=0
	}
	if b=1 {
		if lang=0 : dialog "loop count overflow.",1,"WARNING."
		if lang=1 : dialog "EFCgɒB܂.\n𒆎~܂.",1,"WARNING"
		goto *escap
	}
	wait 60

;  nes file copy
; ---------------
	a=0 : b=0 : repeat
	title "NSF file searching. ["+a+"/100]"
	if lmck=0 : exist "make_nsf.nes" : if strsize!=-1 : break
	if lmck=1 : exist "make_bdt.nes" : if strsize!=-1 : break
	if lmck=2 : exist "make_pmc.nes" : if strsize!=-1 : break
	wait 20 : a++ : if a>100 : b=1 : break
	loop
	exist "nwnsm.bat" : if strsize!=-1 : delete "nwnsm.bat"
	if b=1 {
		if lang=0 : dialog "nsf-tune generate error.",1,"ERROR"
		if lang=1 : dialog "NSFt@CȂ肪܂.",1,"ERROR"
		exec rundir+"\\err_nesm.txt",16
		goto *escap
	}

	if lmck=0 : bcopy "make_nsf.nes",dpath+nsfnam+".nsf" : delete "make_nsf.nes"
	if lmck=1 : bcopy "make_bdt.nes",dpath+nsfnam+".nsf" : delete "make_bdt.nes"
	if lmck=2 : bcopy "make_pmc.nes",dpath+nsfnam+".nsf" : delete "make_pmc.nes"
	delete nsfnam+".h"
	wait 20

	a=0 : repeat : exist dpath+nsfnam+".nsf"
	title "NSF file searching...["+a+"/512]"
	if strsize!=-1 : break
	a++ : if a>512 : break
	wait 2 : loop : b=2

*escap
	chdir exedir : title ver+" - "+fnam : dd_reject 0,1
	a=0 : repeat 9 : objgray cnt+1,1 : loop
	if b=2 : goto *nsfplay
	goto *main


; ---------- ---------- ---------- ---------- ---------- ----------
; [F4] convert BDT-MCK / PMCK system files.
; ---------- ---------- ---------- ---------- ---------- ----------
*cv_files
	if lang=0 : dialog "include BDT / PMCK files\nfor mck directory?",2,"File Convert"
	if lang=1 : dialog "BDT / PMCK ϊ@\𓱓܂B\n낵łH",2,"g"
	if stat=7 : goto *main
	a=0 : ppmsg="" : temp="" : b=5

; bdt file checksum
	chdir exedir+"\\mckbdt"
	exist "fds.h"      : if strsize=8034  : bcopy "fds.h","..\\mck\\bdt_fds.h" : a++
	exist "sounddrv.h" : if strsize=28355 : bcopy "sounddrv.h","..\\mck\\bdt_sdrv.h" : a++
	exist "mckc.exe"   : if strsize=73728 : bcopy "mckc.exe","..\\mck\\bdtmckc.exe" : a++

	exist "make_nsf.txt" : if strsize=1165 {
		temp=""
		notesel temp : noteload "make_nsf.txt"
		noteadd "\t.include\t\"bdt_sdrv.h\"",47,1
		noteadd "\t.include\t\"bdt_fds.h\"",48,1
		notesave exedir+"\\mck\\make_bdt.txt"
		a++
	}

; pmck file checksum
	chdir exedir+"\\pmck"
	exist "fds.h"      : if strsize=8204  : bcopy "fds.h","..\\mck\\p_fds.h" : a++
	exist "freqdata.h" : if strsize=4083  : bcopy "freqdata.h","..\\mck\\p_freqdt.h" : a++
	exist "n106.h"     : if (strsize=7231)|(strsize=7272) : bcopy "n106.h","..\\mck\\p_n106.h" : a++
	if strsize=7272 : b++
	exist "sounddrv.h" : if (strsize=29588)|(strsize=29578)|(strsize=29621) : bcopy "sounddrv.h","..\\mck\\p_snddrv.h" : a++
	if strsize=29578 : b++
	if strsize=29621 : b++
	exist "vrc7.h"     : if strsize=7384  : bcopy "vrc7.h","..\\mck\\p_vrc7.h" : a++
	exist "pmckc.exe"  : if strsize=52224 : bcopy "pmckc.exe","..\\mck\\pmckc.exe" : a++

	exist "make_nsf.txt" : if strsize=1219 {
		temp=""
		notesel temp : noteload "make_nsf.txt"
		noteadd "\t.include\t\"p_snddrv.h\"",50,1
		noteadd "\t.include\t\"p_fds.h\"",51,1
		noteadd "\t.include\t\"p_vrc7.h\"",52,1
		noteadd "\t.include\t\"p_n106.h\"",53,1
		noteadd "\t.include\t\"p_freqdt.h\"",54,1
		notesave exedir+"\\mck\\make_pmc.txt"
		a++
	}

	if a=11 {
		if lang=0 : dialog "file convert complete.",1,"Normally"
		if lang=1 : dialog "ł܂B\npmck 0.0"+b,1,"I"
	} else {
		if lang=0 : dialog "file convert uncompleted...",1,"File Error"
		if lang=1 : dialog "łĂ܂B",1,"ُI"
	}

	a=0 : b=0 : ppmsg="" : temp=""
	goto *main
